c--log2ggp.f
c--converts .tsf files (sec or min) to ggp format by month
c--modified from tsf2ggpm.f may 2011
c----------------------------------------------------------------------------
      program LOG2GGP
      implicit real*8(a-h,o-y),integer*4(i-n),logical(z)
      character*255 hline
      character*40 hfile,fname1,fname2,fname9
	character*30 fmt1
	character*8 ch1,ch1t,c7,c9,chdate,cstar
	character*6 ch2,ch2t
	character*3 cxt
	character*2 cyy,cmm,cdd,cc,yy,mm,dd,cpp
      character*1 ans
	logical*1 lexist,lfout,lzero
c
      data cpp/'l1'/,cxt/'log'/,cstar/'********'/
c
      write(*,'(/a)') ' LOG2GGP - converts TSF log files to GGP'
      write(*,'(a)')  ' ----------------------------------------'
c
c--auxiliary file contains
      open(9,file='log2ggp.in')
c  iy1,im1,id1 = date of first sample required
c  iy2,im2,id2 = date of last sample required
      read(9,*) iy1,im1,id1
      read(9,*) iy2,im2,id2
c--convert to fractional year
      call ymdfy(iy2,im2,id2,23,59,59,fyear2)
	open(12,file='log2ggp.tmp')
      write(12,'(a,3i5,f16.10)') ' ending date ',iy2,im2,id2,fyear2
c
c--set the flags
c  nf  = index for daily file
c  ky is truncated year (2 digits)
	nf=1
	iy=iy1
      ky=iy-100*(iy/100)
	km=im1
	kd=id1
	im=1
c
c--construct input filename
  10  call intch2(ky,cyy)
      call intch2(km,cmm)
	call intch2(kd,cdd)
c--check if end of time period
      iy=1900+ky
	if(ky.lt.50) iy=iy+100
      call ymdfy(iy,km,kd,0,0,0,fyear1)
      if(fyear1.gt.fyear2) goto 100
	fname1=cpp//cyy//cmm//cdd//".046"
c	write(*,'(2a)') ' input ',fname1
c--first file of month, get output name
	if(nf.eq.1) then
        fname2='ap'//cyy//cmm//"00."//cxt
        write(12,'(2a)') ' output file is ',fname2
        write(*,'(2a)') ' output ',fname2
        open(2,file=fname2)
c--find start/end days and number of samples this month
c	  iy=1900+ky
c	  if(ky.lt.50) iy=iy+100
        call julian(iy,km,1,0,0,0,rjda)
        call ndaym(iy,km,nday)
        call julian(iy,km,nday,23,59,59,rjdb)
	  write(12,'(a,2f15.6)') ' month limits ',rjda,rjdb
        write(12,'(a,2i7)') ' year and month ',iy,km
	endif
c--check if end of time period
c      call ymdfy(iy,km,kd,0,0,0,fyear1)
c      if(fyear1.gt.fyear2) goto 100
c--does this day file exist
      inquire(file=fname1,exist=lexist)
	if(.not.lexist) then
        write(*,'(2a)')  '    missing ',fname1
	  write(12,'(2a)') '    missing ',fname1
c--get next file
        goto 40
      endif
c
c--start reading
  12	open(1,file=fname1)
      write(12,'(2a)') '   reading ',fname1
      write(*,'(2a)')  '   reading ',fname1
  30  read(1,'(a)',end=40,err=990) hline
c--screen out lines with specific strings
      i1=index(hline,'******')
	if(i1.gt.0) goto 30 
	i2=index(hline,'.TWM')
	if(i2.gt.0) goto 30
	i3=index(hline,'----------')
	if(i3.gt.0) goto 30
c--write to monthly ggp file
      lh=len_trim(hline)
	write(2,'(a)') hline(1:lh)
      goto 30
c
c--next day file
  40  close(1)
      kd=kd+1
      nf=nf+1
	im=im+1
	if(kd.le.nday) goto 10
c--end this month file
      close(2)
c
c--new month
      km=km+1
c--change year?
	if(km.gt.12) then
        iy=iy+1
        ky=iy-100*(iy/100)
	  km=1
      endif
      nf=1
	kd=1
	im=1
      goto 10
6030  format(a,i5,5i3,f15.6,i9) 
c
c--finish
 100  close(2)
      write(*,*) ' done'
      stop
c
c--errors
 990  write(*,*) 'error reading ',fname1,' last line read: '
      write(*,'(a)') hline
 999  stop
      end
c----------------------------------------------------------
      subroutine datim(ch1,ch2,iy,mo,id,ih,mn,is,kk)
c
c  exchanges date and time from character arrays
c    kk=0 goes from character to integer date/time
c    kk=1 goes from integer to character date/time
c
      implicit integer*4(i-n)
      character*8 ch1
	character*6 ch2
	character*2 cd
c
      if(kk.eq.0) then
        call chint4(ch1(1:4),iy)
	  call chint2(ch1(5:6),mo)
	  call chint2(ch1(7:8),id)
	  call chint2(ch2(1:2),ih)
	  call chint2(ch2(3:4),mn)
	  call chint2(ch2(5:6),is)
	else
        call intch4(iy,ch1(1:4))
	  call intch2(mo,ch1(5:6))
	  call intch2(id,ch1(7:8))
	  call intch2(ih,ch2(1:2))
	  call intch2(mn,ch2(3:4))
	  call intch2(is,ch2(5:6))
	endif
c
      return
	end

c--------------------------------------------------------------------------
      subroutine chint2(cd,id)
c
c--converts character string 'cd' to integer 'id'
c  id = 2 characters
c
      implicit integer*4(i-n)
      character*2 cd,cdc
      character*1 dum(2)
      equivalence (cdc,dum)
c
      cdc=cd
      id=0
      do ii=1,2
        k=ichar(dum(3-ii))-48
        id=id+k*(10.0**(ii-1))
      enddo
c
      return
      end
c---------------------------------------------------------------------------
      subroutine chint4(cd,id)
c
c--converts character string 'cd' to integer 'id'
c  id = 2 characters
c
      implicit integer*4(i-n)
      character*4 cd,cdc
      character*1 dum(4)
      equivalence (cdc,dum)
c
      cdc=cd
      id=0
      do ii=1,4
        k=ichar(dum(5-ii))-48
        id=id+k*(10.0**(ii-1))
      enddo
c
      return
      end
c--------------------------------------------------------------------------
      subroutine intch2(id,cd)
c
c--converts integer 'id' to character string 'cd'
c  id = 2 digits
c
      implicit integer*4(i-n)
      character*2 cd,cdc
      character*1 dum(2)
      equivalence (cdc,dum)
c
      n=id
      do ii=1,2
        k=n-10*(n/10)
        dum(3-ii)=char(k+48)
        n=n/10
      enddo
      cd = cdc
c
      return
      end
c--------------------------------------------------------------------------
      subroutine intch4(id,cd)
c
c--converts integer 'id' to character string 'cd'
c  id = 4 digits
c
      implicit integer*4(i-n)
      character*4 cd,cdc
      character*1 dum(4)
      equivalence (cdc,dum)
c
      n=id
      do ii=1,4
        k=n-10*(n/10)
        dum(5-ii)=char(k+48)
        n=n/10
      enddo
      cd = cdc
c
      return
      end
